# ssh

`ssh` is what sets ttylde apart from other social networks. you connect *directly to another computer's console* instead of connecting via a web page or a mobile app.

Before the days of the world-wide-web, this is how all computer work got done.

People used to use a tool called [`telnet`](https://en.wikipedia.org/wiki/telnet) for this purpose. Nowadays, we use `ssh`.

___

# How to make an ssh key

This method will create two keys: a public and a private key. This is a method of encryption called [public key encryption](https://en.wikipedia.org/wiki/Public-key_cryptography).

Make sure to *always* keep your private key private! Otherwise, bad people can do bad things while pretending to be you.

___

If you have any questions, be sure to ask on IRC! The channel is `#ttylde`.

See [the wiki page on IRC](https://ttylde.karx.xyz/wiki.php?page=irc) for more info.
___

## Generating the keypair

1. Open your terminal
2. Create your .ssh directory if it doesn't exist:

```bash
mkdir -m 700 ~/.ssh
```
3. Create your keys:

```bash
ssh-keygen -t ed25519 -a 100
```
- If you accept the defaults, your public key and private key will be located at `~/.ssh/id_ed25519.pub` and `~/.ssh/id_ed25519`, respectively.
- Paste the contents of your public key file into the SSH Key field on the signup form

## Using the keypair

Once an admin approves your application, simply run the following command to connect:

```bash
ssh -i ~/.ssh/your_key_file username@ttylde.karx.xyz
```

where `username` is your username (~karx would use `karx@ttylde.karx.xyz`)

___

### Using ssh on legacy windows

Older versions of windows do not come with ssh preinstalled, and you will need to install a third party tool. Below are some recommendations:

- [Windows subsystem for Linux](https://docs.microsoft.com/en-us/windows/wsl/install-win10)
- [msys2](http://www.msys2.org/)
- [git bash](https://git-scm.com/)

After this, follow the instructions above.
